Bullet Collision Detection & Physics Library: btMultiSphereShape Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Private Attributes | List of all members
btMultiSphereShape Class Reference

The btMultiSphereShape represents the convex hull of a collection of spheres. More...

`#include <btMultiSphereShape.h>`

Inheritance diagram for btMultiSphereShape:
[legend]
Collaboration diagram for btMultiSphereShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btMultiSphereShape (const btVector3 *positions, const btScalar *radi, int numSpheres)
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
| CollisionShape Interface.
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
| btConvexShape Interface
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
int | getSphereCount () const
const btVector3 & | getSpherePosition (int index) const
btScalar | getSphereRadius (int index) const
virtual const char * | getName () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexInternalAabbCachingShape
virtual void | setLocalScaling (const btVector3 &scaling)
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
void | recalcLocalAabb ()
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs'
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const =0
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const =0
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const =0
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
virtual void | setLocalScaling (const btVector3 &scaling)=0
virtual const btVector3 & | getLocalScaling () const =0
virtual void | setMargin (btScalar margin)=0
virtual btScalar | getMargin () const =0
virtual int | getNumPreferredPenetrationDirections () const =0
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const =0
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
| getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
virtual void | setLocalScaling (const btVector3 &scaling)=0
virtual const btVector3 & | getLocalScaling () const =0
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const =0
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
virtual void | setMargin (btScalar margin)=0
virtual btScalar | getMargin () const =0
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btAlignedObjectArray< btVector3 > | m_localPositionArray
btAlignedObjectArray< btScalar > | m_radiArray

## Additional Inherited Members
Protected Member Functions inherited from btConvexInternalAabbCachingShape
| btConvexInternalAabbCachingShape ()
void | setCachedLocalAabb (const btVector3 &aabbMin, const btVector3 &aabbMax)
void | getCachedLocalAabb (btVector3 &aabbMin, btVector3 &aabbMax) const
void | getNonvirtualAabb (const btTransform &trans, btVector3 &aabbMin, btVector3 &aabbMax, btScalar margin) const
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btMultiSphereShape represents the convex hull of a collection of spheres.

You can create special capsules or other smooth volumes. It is possible to animate the spheres for deformation, but call 'recalcLocalAabb' after changing any sphere position/radius

Definition at line 26 of file btMultiSphereShape.h.

## Constructor & Destructor Documentation

## ◆ btMultiSphereShape()

btMultiSphereShape::btMultiSphereShape | ( | const btVector3 * | positions,
|  | const btScalar * | radi,
|  | int | numSpheres
| ) |  |

Definition at line 25 of file btMultiSphereShape.cpp.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

void btMultiSphereShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors
| ) |  | const
| virtual

Implements btConvexShape.

Definition at line 91 of file btMultiSphereShape.cpp.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btMultiSphereShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ calculateLocalInertia()

void btMultiSphereShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia
| ) |  | const
| virtual

CollisionShape Interface.

Implements btCollisionShape.

Definition at line 126 of file btMultiSphereShape.cpp.

## ◆ calculateSerializeBufferSize()

int btMultiSphereShape::calculateSerializeBufferSize | ( |  | ) | const
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 90 of file btMultiSphereShape.h.

## ◆ getName()

virtual const char * btMultiSphereShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 60 of file btMultiSphereShape.h.

## ◆ getSphereCount()

int btMultiSphereShape::getSphereCount | ( |  | ) | const
| inline

Definition at line 45 of file btMultiSphereShape.h.

## ◆ getSpherePosition()

const btVector3 & btMultiSphereShape::getSpherePosition | ( | int | index | ) | const
| inline

Definition at line 50 of file btMultiSphereShape.h.

## ◆ getSphereRadius()

btScalar btMultiSphereShape::getSphereRadius | ( | int | index | ) | const
| inline

Definition at line 55 of file btMultiSphereShape.h.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btMultiSphereShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

btConvexShape Interface

Implements btConvexShape.

Definition at line 45 of file btMultiSphereShape.cpp.

## ◆ serialize()

const char * btMultiSphereShape::serialize | ( | void * | dataBuffer,
|  | btSerializer * | serializer
| ) |  | const
| virtual

fills the dataBuffer and returns the struct name (and 0 on failure)

Reimplemented from btConvexInternalShape.

Definition at line 144 of file btMultiSphereShape.cpp.

## Member Data Documentation

## ◆ m_localPositionArray

btAlignedObjectArray<btVector3> btMultiSphereShape::m_localPositionArray
| private

Definition at line 29 of file btMultiSphereShape.h.

## ◆ m_radiArray

btAlignedObjectArray<btScalar> btMultiSphereShape::m_radiArray
| private

Definition at line 30 of file btMultiSphereShape.h.

The documentation for this class was generated from the following files:

- btMultiSphereShape.h
- btMultiSphereShape.cpp